︠62e34ce5-30d4-4306-8410-3a6b49d30b4ci︠
%html
<p>This worksheet parses the login data to find the number of simultaneous worksheets and plot the results.</p>

︡2f49a0a9-9de2-448d-a3c0-f3e6a89cb9b7︡{"html": "<p>This worksheet parses the login data to find the number of simultaneous worksheets and plot the results.</p>"}︡
︠277f6aa5-6628-4c3d-b2ab-0e7b3d937f7c︠
# Get login data from the "last" program
from subprocess import Popen, PIPE
p = Popen("last", stdout=PIPE,shell=True)
output = p.communicate()[0]

from datetime import datetime, timedelta

# define an "interesting" user name
# this definition gets any users with the same name
# as the currently executing worksheet user.
def interesting_user(s):
    return s[:8]==os.environ['USER'][:8]
# parse the data
print "Interesting user: ",os.environ['USER'][:8]
data=[] 
i=0   
for line in output.split('\n'):
    i+=1
    tokens=line.split()
    if len(tokens)==0 or not interesting_user(tokens[0]):
        continue
    d=dict(user=tokens[0])
    d['action']='log in'
    d['time']=datetime.strptime('%s %s 2011 %s'%(tokens[4],tokens[5],tokens[6]), '%b %d %Y %H:%M')
    logindate=d['time']
    d['log id']=i
    data.append(d)
    if tokens[7]=='-':
        d=dict(user=tokens[0])
        d['action']='log out'

        try:
            d['time']=datetime.strptime('%s %s 2011 %s'%(tokens[4],tokens[5],tokens[8]), '%b %d %Y %H:%M')
            if d['time']<logindate:
                d['time']+=timedelta(1r) # add one day
        except ValueError:
            continue
        d['log id']=i
        data.append(d)

# sort the data by time
data.sort(key=lambda x: x['time'])

# now create two corresponding lists of dates and number of logged in users
logged_in=0
starting_date=data[0]['time']
dates=[]
users=[]
for d in data:
    if d['action']=='log in':
        logged_in+=1
    elif d['action']=='log out':
        logged_in-=1
    dates.append(d['time'])
    users.append(logged_in)
︡4caddd00-ae4e-479f-b2c0-a8461c78bfe7︡{"stdout": "Interesting user:  sagenbws"}︡
︠ba2db4aa-f287-485d-9077-9a54003a65b7︠
# here is a static graph

import matplotlib
from pylab import figure, savefig
fig = figure(figsize=[15,5])
ax = fig.add_subplot(111)
ax.plot_date(dates, users, '-',drawstyle='steps')
ax.grid(True)

fig.autofmt_xdate()
savefig('test.png',bbox_inches='tight')
︡636a32bc-8af5-4128-954e-35e2b2be2451︡︡
︠0faeb701-3b89-48d5-acea-e3aaddc69683︠
# now plot using matplotlib
import matplotlib
from pylab import figure, savefig

@interact
def _(view=range_slider(0,len(dates),1,default=(0,len(dates)))):
    fig = figure(figsize=[15,5])
    ax = fig.add_subplot(111)
    ax.plot_date(dates[view[0]:view[1]], users[view[0]:view[1]], '-',drawstyle='steps')
    ax.grid(True)
    
    fig.autofmt_xdate()
    savefig('test.png',bbox_inches='tight')
︡668ec48b-87e1-4352-9d74-2d5afa3f4b8b︡︡
